BaseEditor
Keywords: net.sf.colorer.editor.BaseEditor,BaseEditor interface

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.colorer.editor
Interface BaseEditor

All Known Implementing Classes:
  BaseEditorNative

public interface BaseEditor

Method Summary
`void` | `addRegionHandler(RegionHandler rh, Region filter)` Adds specified RegionHandler object into the parse process.
`java.lang.String` | `chooseFileType(java.lang.String fname)` Chooses filetype according to the filename and first line of text
`RegionDefine` | `getBackground()` Current Background Region (def:Text)
`java.lang.String` | `getFileType()` Returns Currently selected file type
`RegionDefine` | `getHorzCross()` Current Horizontal Rule (def:HorzCross)
`LineRegion[]` | `getLineRegions(int lno)` Return parsed and colored LineRegions of requested line.
`PairMatch` | `getPairMatch(int lineNo, int pos)` Searches and creates pair match object.
`RegionDefine` | `getVertCross()` Current Vertical Rule (def:VertCross)
`void` | `idleJob(int time)` Tries to do some parsing job while user is doing nothing.
`void` | `lineCountEvent(int newLineCount)` Informs about total lines count change.
`void` | `modifyEvent(int topLine)` Informs BaseEditor object about text modification event.
`void` | `modifyLineEvent(int line)` Informs about single line modification event.
`void` | `removeRegionHandler(RegionHandler rh)` Removes previously added region handler.
`void` | `searchGlobalPair(PairMatch pm)` Searches pair match in all available text, possibly, making additional processing.
`void` | `searchLocalPair(PairMatch pm)` Searches pair match in currently visible text.
`void` | `setBackParse(int backParse)` Specifies number of lines, for which parser would be able to run continual processing without highlight invalidation.
`void` | `setFileType(java.lang.String typename)` Changes used file type
`void` | `setRegionCompact(boolean compact)` LineRegionsSupport object preferences.
`void` | `setRegionMapper(java.lang.String cls, java.lang.String name)` Installs specified RegionMapper.
`void` | `validate(int lno)` Validates current state of the editor and runs parser, if needed.
`void` | `visibleTextEvent(int wStart, int wSize)` Informs about changes in visible range of text lines.

Method Detail

### setRegionCompact

    public void setRegionCompact(boolean compact)

  LineRegionsSupport object preferences. Installs specified RegionStore (basically HRDRegionStore), which maps HRC Regions into color data, sets default size (in lines) of Regions structure cache.

  Parameters:
    `compact` - Creates LineRegionsSupport (false) or LineRegionsCompactSupport (true) object to store lists of RegionDefine's

### setFileType

    public void setFileType(java.lang.String typename)

  Changes used file type

### chooseFileType

    public java.lang.String chooseFileType(java.lang.String fname)

  Chooses filetype according to the filename and first line of text

### getFileType

    public java.lang.String getFileType()

  Returns Currently selected file type

### setBackParse

    public void setBackParse(int backParse)

  Specifies number of lines, for which parser would be able to run continual processing without highlight invalidation.

  Parameters:
    `backParse` - Number of lines. If <= 0, dropped into default value.

### setRegionMapper

    public void setRegionMapper(java.lang.String cls,
                                java.lang.String name)

  Installs specified RegionMapper.

### addRegionHandler

    public void addRegionHandler(RegionHandler rh,
                                 Region filter)

  Adds specified RegionHandler object into the parse process.

  Parameters:
    `filter` - If not null, handler would be activated only if passed regions have specified `filter` parent. This allows to optimize performance and disable unnecesary JNI context switches.

### removeRegionHandler

    public void removeRegionHandler(RegionHandler rh)

  Removes previously added region handler.

### getBackground

    public RegionDefine getBackground()

  Current Background Region (def:Text)

### getVertCross

    public RegionDefine getVertCross()

  Current Vertical Rule (def:VertCross)

### getHorzCross

    public RegionDefine getHorzCross()

  Current Horizontal Rule (def:HorzCross)

### getPairMatch

    public PairMatch getPairMatch(int lineNo,
                                  int pos)

  Searches and creates pair match object. Returned object can be used later in the pair search methods. This object is valid only until reparse of it's line occured. After that event information about line region's references in it becomes invalid and, if used, can produce faults.

  Parameters:
    `lineNo` - Line number, where to search paired region.
    `pos` - Position in line, where paired region to be searched. Paired Region is found, if it includes specified position or ends directly at one char before line position.

### searchLocalPair

    public void searchLocalPair(PairMatch pm)

  Searches pair match in currently visible text.

  Parameters:
    `pm` - Unmatched pair match

### searchGlobalPair

    public void searchGlobalPair(PairMatch pm)

  Searches pair match in all available text, possibly, making additional processing.

  Parameters:
    `pm` - Unmatched pair match

### getLineRegions

    public LineRegion[] getLineRegions(int lno)

  Return parsed and colored LineRegions of requested line. This method validates current cache state and, if needed, calls Colorer parser to validate modified block of text. Size of reparsed text is choosed according to information about visible text range and modification events.

  To do:
    If number of lines, to be reparsed is more, than backParse parameter, then method will return null, until validate() method is called.

### validate

    public void validate(int lno)

  Validates current state of the editor and runs parser, if needed. This method can be called periodically in background thread to make possible background parsing process.

  Parameters:
    `lno` - Line number, for which validation is requested. If this number is in the current visible window range, the part of text is validated, which is required for visual repaint. If this number is equals to -1, all the text is validated. If this number is not in visible range, optimal partial validation is used

### idleJob

    public void idleJob(int time)

  Tries to do some parsing job while user is doing nothing.

  Parameters:
    `time` - integer between 0 and 100, shows an abount of time, available for this job.

### modifyEvent

    public void modifyEvent(int topLine)

  Informs BaseEditor object about text modification event. All the text becomes invalid after the specified line.

  Parameters:
    `topLine` - Topmost modified line of text.

### modifyLineEvent

    public void modifyLineEvent(int line)

  Informs about single line modification event. Generally, this type of event can be processed much faster because of pre-checking line's changed structure and cancelling further parsing in case of unmodified text structure.

  Parameters:
    `line` - Modified line of text.
  To do:
    Not used yet! This must include special 'try' parse method.

### visibleTextEvent

    public void visibleTextEvent(int wStart,
                                 int wSize)

  Informs about changes in visible range of text lines. This information is used to make assumptions about text structure and to make faster parsing.

  Parameters:
    `wStart` - Topmost visible line of text.
    `wSize` - Number of currently visible text lines. This number must includes all partially visible lines.

### lineCountEvent

    public void lineCountEvent(int newLineCount)

  Informs about total lines count change. This must include initial lines number setting.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003 Cail Lomecb. All Rights Reserved.